<?php
// 设置错误报告
ini_set('display_errors', 1);
error_reporting(E_ALL);

// 数据库连接信息
$db_host = '192.168.2.4';
$db_port = 3307;
$db_name = 'task_reporter';
$db_user = 'task_reporter';
$db_pass = 'Pass12349ers!';

// 创建数据库连接
try {
    $pdo = new PDO("mysql:host=$db_host;port=$db_port;dbname=$db_name", $db_user, $db_pass);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    $pdo->exec("SET NAMES utf8");
    echo "数据库连接成功！<br>";
} catch (PDOException $e) {
    die("数据库连接失败: " . $e->getMessage());
}

// 查询最近的记录
try {
    $stmt = $pdo->query("SELECT * FROM task ORDER BY id DESC LIMIT 20");
    $records = $stmt->fetchAll(PDO::FETCH_ASSOC);
    
    echo "<h2>最近20条记录</h2>";
    
    if (count($records) > 0) {
        echo "<table border='1' cellpadding='5' cellspacing='0'>";
        echo "<tr><th>ID</th><th>用户名</th><th>工具名称</th><th>任务名称</th><th>节省时间</th><th>花费时间</th><th>时间戳</th></tr>";
        
        foreach ($records as $record) {
            echo "<tr>";
            echo "<td>{$record['id']}</td>";
            echo "<td>{$record['username']}</td>";
            echo "<td>{$record['tool_name']}</td>";
            echo "<td>{$record['task_name']}</td>";
            echo "<td>{$record['time_saved']}</td>";
            echo "<td>{$record['time_cost']}</td>";
            echo "<td>{$record['timestamp']}</td>";
            echo "</tr>";
        }
        
        echo "</table>";
    } else {
        echo "没有找到记录";
    }
} catch (PDOException $e) {
    echo "查询失败: " . $e->getMessage();
}

// 检查API请求日志
echo "<h2>API请求日志检查</h2>";

// 检查api.php是否正确处理请求
echo "<p>请确认以下几点：</p>";
echo "<ol>";
echo "<li>api.php文件是否正确接收和处理请求</li>";
echo "<li>数据库连接信息是否正确</li>";
echo "<li>TaskReporter.py是否正确发送数据到api.php</li>";
echo "</ol>";

// 显示刷新页面的链接
echo "<p><a href='query_task_data.php'>刷新数据查询页面</a></p>";
?>
